<?PHP
 /*
    GeoCounter version 0.1
    original author: Hutch Ingold ( hutch.ingold@gmail.com )

    This script is made available under the terms of the GPL (http://www.gnu.org/copyleft/gpl.html)

    Credits:
             Georeferencing Ip addresses through http://hostip.info

    Requirements:
             GD library and PHP version 4.0+ (just to be sure)
             **The PHP function fnmatch() is Unix/Linux dependant so for now
             this will not run in a windows environment. I'll rewrite it soon
             but I don't like catering to windows so maybe you should switch
             hosting services instead!!

    Synopsis:
             This counter attempts to translate hits into physical locations,
             displaying them as dots on a map of the world. This allows a better
             visualization of from whence hits are comming (check out that
             grammer) than log parsing tools.
             To use inlclude this snippet in your page:

                <a href="/path/to/script/counter.php?action=display">
                   <img src="/path/to/script/counter.php" alt="GeoCounter" /></a>

             You need to replace "/path/to/script/" with the path to the location
             (relative or absolute) of this file.

             If you don't want the GeoCounter image to appear just use:

                <img src="path/to/script/counter.php?style=trans" alt="geocounter"/>

               You need to replace "/path/to/script/" with the path to the location
             (relative or absolute) of this file.


             To reset the counter:
                -re-unzip or untar the archive and copy the "gcpic_0_0.png" into the scripts directory
                -erase or move the old png file. It will have changed its name to reflect the number of
                 known and unknown number of hits on the site.

   Future Plans:
              -Explore the idea of storing the number of hits inside the headers
               of the image rather than using the filename. Perhaps exif headers
               could store more info such as a breakdown of hits by continent
 */

   /** Main **/
   if($_GET['action'] == 'display') { display();}
   else{hit();}


   /**Functions**/

   function hit(){

     $ip = $_SERVER['REMOTE_ADDR'];
     $results=file_get_contents("http://www.hostip.info/api/get.html?ip=$ip&position=true"); //catch errors later

     //parse response
     preg_match('/Latitude: (.*)/', $results, $lat);
     preg_match('/Longitude: (.*)/', $results, $lon);

     $info = getfileinfo();

         //translate
     if($lon[1]=="" || $lat[1]==""){
                     $newfilename = 'gcpic_'.$info['matched_hits'].'_'.($info['unmatched_hits']+1).".png";
                     rename($info['filename'], $newfilename);
                     return;}

     else{
          $image = imagecreatefrompng($info['filename']); //load image 1406*703
          $x = ($lon[1]*3.905555556)+703;

               if($lat[1] > 0){
                   $y = (351.5 - ($lat[1]*3.90555556));}
                   if($lat[1] < 0){
                   $y = ((($lat[1]*-1)*3.90555556)+351.5);}

                   $dot_color = imagecolorallocate($image, 255,0,0);
                   imagefilledellipse($image, $x,$y, 2, 2, $dot_color);

                    //output image

                     imagepng($image,$info['filename']);
                     imagedestroy($image);

                     //rename file
                     $newfilename = 'gcpic_'.($info['matched_hits']+1).'_'.$info['unmatched_hits'].".png";
                     rename($info['filename'], $newfilename);





      }
      if($_GET['style']=='trans')
           {
           $im = imagecreatetruecolor(5,5);
           $trans = imagecolorallocatealpha($im, 255,255,255,127);
           imagefill($im, 0,0,$trans);
           header("HTTP/1.1 202 Accepted");
           header("Content-type: image/png");
           imagepng($im);
           imagedestroy($im);
           }
      else{
           header("HTTP/1.1 202 Accepted");
           header("Content-type: image/png");
           $gif= fopen('geocounter.gif',r);
           fpassthru($gif);
           }

   }

   function display()
   {
    $info = getfileinfo();
    print('
   <?xml version="1.0" encoding="utf-8"?>
   <!DOCTYPE html PUBLIC "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" "-//W3C//DTD XHTML 1.0 Strict//EN">
   <html lang="en" xmlns="http://www.w3.org/1999/xhtml">

    <head>
    <title>Geocounter</title>
    <meta http-equiv="Content-Type" content="text/xhtml; charset=UTF-8"/>
    <style type="text/css">
           <!--
           table{
		font-family: arial,helvetica, sans-serif;
		font-size: 10px;
		border-style: solid;
		border-style: solid;
		border-color: #FFFFFF;
		border-width: 1px;
		}
           body{
                font-family: arial,helvetica, sans-serif;
                font-size: 10px;
                color:#FFFFFF;
                background-color: #000000;
                text-align: center;
                }
           a, a:visited	{
		color: #FFD951;
		}
           -->
    </style>
  </head>

  <body>
        <table class="content">
          <tr><th>GeoCounter - Hits</th></tr>
          <tr><td><p>Only successfully mapped hits are plotted here. You can help
          make this more accurate by going to <a href="http://www.hostip.info">
          <img src="http://www.hostip.info/images/button-86x18.gif" alt="Hostip.info"/></a> and lending a hand.</p>
          <p>So far it looks like you have had '.$info['matched_hits'].' hits we
          could trace and '.$info['unmatched_hits'].' hits we couldn\'t</p>
           </td></tr>
          <tr><td><img src="'.$info['filename'].'" alt="Map"/></td></tr>
        </table>
  </body>
  </html>
           ');

   }

   function getfileinfo()
   {
   if ($handle = opendir('.')) {
     while (false !== ($file = readdir($handle))) {
      if (fnmatch("gcpic_*_*.png", $file)) {

          preg_match_all('/_([0-9]+)/', $file, $mh);


          $matched_hits = $mh[1][0];
          $unmatched_hits = $mh[1][1];


          $fileinfo = array('filename'=>$file,
                            'matched_hits'=>$matched_hits,
                            'unmatched_hits'=>$unmatched_hits);
          return($fileinfo);
     }
     }
   }
   }

?>
